<template>
  <q-page class="flex bg-gray-3">
    <q-card
      flat
      v-if="carts && carts.length == 0"
      class="no-carts flex flex-center q-mx-auto"
    >
      <q-card-section>
        <div class="text-h5 text-primary">{{ $t('PublicCarts.NoLists') }}</div>
      </q-card-section>
    </q-card>
    <q-card flat v-if="carts && carts.length > 0" class="full-width q-pa-sm">
      <q-card-section>
        <q-list separator>
          <q-item
            clickable
            v-touch-pan.mouse.left.stop.prevent="
              (evt) => handlePanLeft(evt, cart)
            "
            v-touch-pan.mouse.right.stop.prevent="
              (evt) => handlePanRight(evt, cart)
            "
            v-ripple
            @click="(evt) => onCartClick(evt, cart)"
            v-for="cart of carts"
            :key="cart.local_id"
            :style="swipeStyle[cart.local_id]"
          >
            <q-item-section class="overflow-hidden">
              {{ cart.name }}
            </q-item-section>
            <q-item-section side>
              <q-btn
                round
                @click.stop.prevent="onShowCartDeleteDialog(cart)"
                color="red"
                text-color="white"
                icon="delete_outline"
              />
            </q-item-section>
            <q-item-section side>
              <q-btn
                @click.stop.prevent="onShowCartUpdateDialog(cart)"
                round
                color="teal"
                text-color="white"
                icon="edit"
              />
            </q-item-section>
          </q-item>
        </q-list>
      </q-card-section>
    </q-card>

    <q-dialog
      @before-hide="() => clearDialog()"
      v-model="showCartCreateDialog"
      persistent
      @keyup.escape="showCartCreateDialog = false"
      @keyup.enter.prevent.stop="addCart"
    >
      <q-card style="min-width: 75vw">
        <q-bar>
          {{ $t('PublicCarts.create') }}
          <q-space />
          <q-btn dense flat icon="close" v-close-popup />
        </q-bar>
        <q-card-section>
          <q-input
            v-model="cartName"
            type="text"
            :label="$t('PublicCarts.name')"
            @keyup.enter.prevent.stop="addCart"
          />
        </q-card-section>

        <q-card-actions align="right">
          <q-btn
            flat
            icon="add"
            :label="$t('PublicCarts.create')"
            color="green"
            @click.prevent="addCart"
          />
        </q-card-actions>
      </q-card>
    </q-dialog>

    <q-dialog
      @before-hide="() => clearDialog()"
      v-model="showCartUpdateDialog"
      persistent
      @keyup.escape="showCartUpdateDialog = false"
      @keyup.enter.prevent.stop="editCart"
    >
      <q-card style="min-width: 75vw">
        <q-bar>
          {{ $t('PublicCarts.change') }}
          <q-space />
          <q-btn dense flat icon="close" v-close-popup />
        </q-bar>
        <q-card-section>
          <q-input
            v-model="updatedCart.name"
            type="text"
            :label="$t('PublicCarts.name')"
            @keyup.enter.prevent.stop="editCart"
          />
        </q-card-section>

        <q-card-actions align="right">
          <q-btn
            flat
            icon="save"
            :label="$t('PublicCarts.save')"
            color="teal"
            @click.prevent="editCart"
          />
        </q-card-actions>
      </q-card>
    </q-dialog>

    <q-dialog
      @before-hide="() => clearDialog()"
      v-model="showCartDeleteDialog"
      persistent
      @keyup.escape="showCartDeleteDialog = false"
      @keyup.enter.prevent.stop="deleteCart"
    >
      <q-card style="min-width: 75vw">
        <q-bar>
          {{ $t('PublicCarts.remove') }}
          <q-space />
          <q-btn dense flat icon="close" v-close-popup />
        </q-bar>

        <q-card-section style="word-wrap: break-word">
          {{ `${$t('PublicCarts.deleteMessage')} "${updatedCart.name}"?` }}
        </q-card-section>

        <q-card-actions align="right">
          <q-btn
            flat
            icon="delete"
            :label="$t('PublicCarts.delete')"
            color="red"
            @click.prevent="deleteCart"
            v-close-popup
          />
        </q-card-actions>
      </q-card>
    </q-dialog>

    <q-page-sticky position="bottom-right" :offset="[18, 18]">
      <q-btn
        fab
        icon="add"
        color="accent"
        @click.prevent="onShowCartCreateDialog()"
      />
    </q-page-sticky>
  </q-page>
</template>

<script lang="ts">
import { defineComponent } from 'vue';

import { useCurrentUserStore } from '../stores/current-user';
import { useAllCartsStore } from 'src/stores/all-carts';

import { mapActions, mapState } from 'pinia';
import { debugLog } from '../utils';
import { Cart } from '../utils/IDBManager';

export default defineComponent({
  name: 'PublicCarts',

  data() {
    return {
      cartName: null,
      updatedCart: null,
      showCartCreateDialog: false,
      showCartUpdateDialog: false,
      showCartDeleteDialog: false,
      swipeOffset: {}, // Объект для хранения смещения свайпа для каждого элемента
      isSwiping: false,
    };
  },

  methods: {
    ...mapActions(useAllCartsStore, {
      onAddCart: 'addCart',
      onDeleteCart: 'deleteCart',
      onEditCart: 'editCart',
    }),
    onCartClick({ evt, ...newInfo }: any, cart: Cart) {
      if (!this.isSwiping)
        this.$router.push({
          name: 'Список',
          query: this.$route.query,
          params: {
            id: cart.local_id,
          },
        });
    },
    handlePanLeft({ evt, ...newInfo }: any, cart: Cart): any {
      this.isSwiping = true;

      console.log('abs', Math.abs(newInfo.distance.x));
      // Обновление смещения свайпа в реальном времени
      this.swipeOffset[cart.local_id] = newInfo.distance.x * -1;
      // Метод обработки свайпа
      if (newInfo?.isFinal) {
        console.log('FINAL');
        setTimeout(() => {
          this.swipeOffset[cart.local_id] = 0;
          this.isSwiping = false;
        }, 500); // Возврат элемента на место, если свайп недостаточно большой
        // Проверка, завершён ли свайп
        if (Math.abs(newInfo.distance.x) > 20) {
          // Проверка, достаточно ли далеко сдвинут элемент
          this.deleteCartWithSwipe(cart); // Удаление элемента, если свайп достаточно большой
        }
      }
    },
    handlePanRight({ evt, ...newInfo }: any, cart: Cart): any {
      this.isSwiping = true;

      console.log('abs', Math.abs(newInfo.distance.x));
      // Обновление смещения свайпа в реальном времени
      this.swipeOffset[cart.local_id] = newInfo.distance.x;
      // Метод обработки свайпа
      if (newInfo?.isFinal) {
        console.log('FINAL');
        setTimeout(() => {
          this.swipeOffset[cart.local_id] = 0;
          this.isSwiping = false;
        }, 500); // Возврат элемента на место, если свайп недостаточно большой
        // Проверка, завершён ли свайп
        if (Math.abs(newInfo.distance.x) > 20) {
          // Проверка, достаточно ли далеко сдвинут элемент
          this.markCart(cart);
        }
      }
    },
    markCart(cart: Cart) {
      console.log('mark');
      // Логика для установки отметки на элементе
    },
    deleteCartWithSwipe(cart: Cart) {
      this.onShowCartDeleteDialog(cart);
    },

    clearDialog() {
      this.cartName = null;
      this.updatedCart = null;
    },

    addCart() {
      if (!this.cartName?.trim()) {
        this.$q.notify({
          message: `${this.$t('PublicCarts.messages.msg3')}`,
          color: 'red',
        });
        return;
      }

      this.showCartCreateDialog = false;

      this.onAddCart({
        name: this.cartName.trim(),
        items: [],
        users: [],
        provider: {
          cart: {
            id: null,
            is_synced: false,
            is_deleted: false,
          },
          id: null,
        },
      })
        .then((resp) => {
          this.$q.notify({
            message: `${this.$t('PublicCarts.messages.msg4')}`,
            color: 'green',
          });
          console.log(resp);
          debugLog('responseAddCart', resp);
          this.$router.push({
            name: 'Список',
            query: this.$route.query,
            params: {
              id: resp.local_id,
            },
          });
        })
        .catch((err) => {
          debugLog('errAddCart', err);
          this.$q.notify({
            message: `${this.$t('PublicCarts.messages.msg5')} ${err}`,
            color: 'red-4',
            icon: 'warning',
          });
        });

      this.clearDialog();
    },
    editCart() {
      if (!this.updatedCart?.name?.trim()) {
        this.$q.notify({
          message: `${this.$t('PublicCarts.messages.msg6')}`,
          color: 'red',
        });
        this.showCartUpdateDialog = false;
        this.updatedCart.name = this.cartName;
        this.clearDialog();
        return;
      }

      if (this.updatedCart.name.trim() == this.cartName.trim()) {
        this.showCartUpdateDialog = false;
        this.updatedCart.name = this.cartName;

        this.clearDialog();
        return;
      }

      this.showCartUpdateDialog = false;

      this.onEditCart(JSON.parse(JSON.stringify(this.updatedCart)))
        .then((resp) => {
          this.$q.notify({
            message: `${this.$t('PublicCarts.messages.msg7')}`,
            color: 'teal',
          });
          debugLog('responseEditCart', resp);
        })
        .catch((err) => {
          debugLog('errEditCart', err);
          this.$q.notify({
            message: `${this.$t('PublicCarts.messages.msg8')} ${err}`,
            color: 'red-4',
            icon: 'warning',
          });
        });

      this.clearDialog();
    },
    deleteCart() {
      this.showCartDeleteDialog = false;
      this.onDeleteCart(this.updatedCart.local_id)
        .then((resp) => {
          this.$q.notify({
            message: `${this.$t('PublicCarts.messages.msg9')}`,
            color: 'red',
          });
          debugLog('responseDelCart', resp);
        })
        .catch((err) => {
          debugLog('errDelCart', err);
          this.$q.notify({
            message: `${this.$t('PublicCarts.messages.msg10')} ${err}`,
            color: 'red-4',
            icon: 'warning',
          });
        });

      this.clearDialog();
    },
    onShowCartCreateDialog() {
      this.showCartCreateDialog = true;
    },
    onShowCartUpdateDialog(cart) {
      this.cartName = cart.name;
      this.updatedCart = cart;
      this.showCartUpdateDialog = true;
    },
    onShowCartDeleteDialog(cart) {
      this.updatedCart = cart;
      this.showCartDeleteDialog = true;
    },
  },
  computed: {
    ...mapState(useCurrentUserStore, ['isLoggedIn']),
    ...mapState(useAllCartsStore, { carts: 'getCarts' }),
    swipeStyle() {
      const obj = {};
      this.carts.forEach((element) => {
        obj[element.local_id] = {
          transform: `translateX(${this.swipeOffset[element.local_id] || 0}px)`,
          transition: 'transform 0.2s ease-in-out',
          // Применение смещения и анимации к элементу
        };
      });

      return obj;
    },
  },
  created() {
    debugLog('PublicCarts Component Created');
  },
  mounted() {
    debugLog('PublicCarts Component Mounted');
  },
});
</script>
